/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2008, 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _STRINGUTIL_H_
#define _STRINGUTIL_H_

#include <string>
#include <vector>
#include <fstream>
#include <iostream>
#include <sstream>





std::vector<std::string> split(std::string text, std::string separators);

template <class T> std::string writeParamDefinition(std::string name, T param, std::vector<std::string> comments) {
	std::ostringstream text;

	text << "## " << name << "\n";
	text << "# \n";
	for(int i=0;i<comments.size();i++) {
		text << "# " << comments[i] << "\n";
	}
	text << "# \n";
	
	text << "set " << name << " " << param << "\n \n";
	
	return 	text.str();
}

template <class T> std::string writeVectorParamDefinition(std::string name, std::vector<T> param, std::vector<std::string> comments) {
	std::ostringstream text;

	text << "## " << name << "\n";
	text << "# \n";
	for(int i=0;i<comments.size();i++) {
		text << "# " << comments[i] << "\n";
	}
	text << "# \n";
	
	text << "set " << name;
	
	for(int i=0;i<param.size();i++) {
		text << " " << param[i];
	}
	
	text << "\n \n";
	
	return 	text.str();
}

#endif // _STRINGUTIL_H_
