/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2008, 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _RECTANGLE_H_
#define _RECTANGLE_H_

#include "../newtEngine/mesh.h"
#include "../newtEngine/entity.h"

#include "../newtEngine/vector3.h"


class RectangleMesh : public Mesh
{
public:
	RectangleMesh(float dim1, int nb1, float dim2, int nb2);
	RectangleMesh(float dim1, int nb1, float texOffset1, float dim2, int nb2, float texOffset2);
	RectangleMesh(float dim1, int nb1, float texBegin1, float texEnd1, float dim2, int nb2, float texBegin2, float texEnd2);
	
		
	~RectangleMesh();
			
	void initFirstParams();
		
	void createVertices(Vector3 *ptr);
	void createColors(Color *ptr);
	void createNormals(Vector3 *ptr);
	void createTexCoords(GLfloat *ptr);
	void createFogCoords(GLfloat *ptr);		
	void createTangents(Vector3 *ptr);	
		
	void createIndices(int numArray, GLuint *ptr);	
		
	
protected:
	float mDim1, mDim2;
	int mNb1, mNb2;	
	float mTexBegin1, mTexBegin2, mTexEnd1, mTexEnd2;
};





#endif // _RECTANGLE_H_
